import { CustomChainConfig } from "@web3auth/base";
import { BaseProvider, BaseProviderConfig, BaseProviderState } from "@web3auth/base-provider";
import { ITorusWalletProvider } from "../../../interface";
export declare class TorusInjectedProvider extends BaseProvider<BaseProviderConfig, BaseProviderState, ITorusWalletProvider> {
    readonly PROVIDER_CHAIN_NAMESPACE = "solana";
    constructor({ config, state }: {
        config: BaseProviderConfig;
        state?: BaseProviderState;
    });
    switchChain(params: {
        chainId: string;
    }): Promise<void>;
    addChain(chainConfig: CustomChainConfig): Promise<void>;
    setupProvider(injectedProvider: ITorusWalletProvider): Promise<void>;
    protected lookupNetwork(): Promise<string>;
    private setupEngine;
    private handleInjectedProviderUpdate;
}
