import { IProvider, RequestArguments } from "@web3auth/base";
import { ISolanaWallet, TransactionOrVersionedTransaction } from "./interface";
export declare class SolanaWallet implements ISolanaWallet {
    provider: IProvider;
    constructor(provider: IProvider);
    requestAccounts(): Promise<string[]>;
    signAndSendTransaction<T extends TransactionOrVersionedTransaction>(transaction: T): Promise<{
        signature: string;
    }>;
    signTransaction<T extends TransactionOrVersionedTransaction>(transaction: T): Promise<T>;
    signAllTransactions<T extends TransactionOrVersionedTransaction>(transactions: T[]): Promise<T[]>;
    signMessage(data: Uint8Array): Promise<Uint8Array>;
    request<T, U>(args: RequestArguments<T>): Promise<U>;
}
